﻿<%@ Page Language="C#" Inherits="System.Web.Mvc.ViewPage<igGridComboEditor.Models.GridModel2>" %>
<%@ Import Namespace="Infragistics.Web.Mvc" %>
<%@ Import Namespace="igGridComboEditor" %>

<!DOCTYPE html>

<html>
<head runat="server">
    <title>ViewPage2</title>
	<script type="text/javascript" src="http://code.jquery.com/jquery-1.6.2.min.js"></script>
	<script type="text/javascript" src="http://ajax.microsoft.com/ajax/jquery.templates/beta1/jquery.tmpl.js"></script>
	<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.16/jquery-ui.min.js"></script>

	<link type="text/css" href="http://localhost/ig_ui12.2/css/structure/jquery.ui.all.css" rel="stylesheet" />	
	<link type="text/css" href="http://localhost/ig_ui12.2/css/themes/infragistics/infragistics.theme.css" rel="stylesheet" />	
	<link type="text/css" href="http://localhost/ig_ui12.2/css/structure/modules/infragistics.ui.shared.css"  rel="stylesheet" />
	<link type="text/css" href="http://localhost/ig_ui12.2/css/structure/modules/infragistics.ui.grid.css" rel="stylesheet" /> 
	<link type="text/css" href="http://localhost/ig_ui12.2/css/structure/modules/infragistics.ui.combo.css" rel="stylesheet" />
	<link type="text/css" href="http://localhost/ig_ui12.2/css/structure/modules/infragistics.ui.editors.css"  rel="stylesheet" />


	<script type="text/javascript" src="http://localhost/ig_ui12.2/js/modules/infragistics.util.js"></script>

	<script type="text/javascript" src="http://localhost/ig_ui12.2/js/modules/i18n/infragistics.dataSource-en.js"></script>
	<script type="text/javascript" src="http://localhost/ig_ui12.2/js/modules/i18n/infragistics.ui.grid-en.js"></script>

	<script type="text/javascript" src="http://localhost/ig_ui12.2/js/modules/infragistics.dataSource.js"></script>
	<script type="text/javascript" src="http://localhost/ig_ui12.2/js/modules/infragistics.ui.shared.js"></script>
	<script type="text/javascript" src="http://localhost/ig_ui12.2/js/modules/infragistics.ui.combo.js"></script>
	<script type="text/javascript" src="http://localhost/ig_ui12.2/js/modules/infragistics.ui.editors.js"></script>
	<script type="text/javascript" src="http://localhost/ig_ui12.2/js/modules/infragistics.ui.grid.framework.js"></script>
	<script type="text/javascript" src="http://localhost/ig_ui12.2/js/modules/infragistics.ui.grid.updating.js"></script>

	<script type="text/javascript">
	// references to maps which contain values displayed in grid cells for keys.
	var productMap, slaveMap;
	// reference to dataSource of slave combo generated by server
	var slaveDataSource;
	// shortcut for once obtained dataSources used by slave combo (SlaveProduct column) for specific values in main combo (Product column)
	var cascadingDataSources = {};
	// indexes of records in slaveDataSource which is used by SlaveCombo editor for a specific value in Product. Like a filter.
	var slaveIndexesForProduct = {0: [0, 1, 2, 3], 1: [4, 5], 2: [6, 7], 3: [8, 9, 10, 11]};
	//
	function productFormatter(val) {
		initMaps();
		return val === null || val === undefined ? '&nbsp;' : productMap[val];
	}
	function slaveFormatter(val) {
		initMaps();
		return val === null || val === undefined ? '&nbsp;' : slaveMap[val];
	}
	//
	function initSlaveComboDS(ui, productValue) {
		// validate ui.rowID for possible addNewRow
		if (ui)
			productValue = ui.rowID === null || ui.rowID < 0 ? -1 : ui.owner.grid.getCellValue(ui.rowID, 'Product');
		// dataSource for slave combo (SlaveProduct column) defined by instant data/value in main combo (Product column)
		var ds = cascadingDataSources[productValue];
		// validate productValue for possible addNewRow
		if (!ds && productValue !== null && productValue >= 0) {
			ds = [];
			var slaveIndexes = slaveIndexesForProduct[productValue];
			var i = slaveIndexes.length;
			while (i-- > 0)
				ds[i] = slaveDataSource[slaveIndexes[i]];
			cascadingDataSources[productValue] = ds;
		}
		// find slave combo and update its dataSource according to value in main combo
		var combo = ui ? ui.editor : $('#Grid1').data('igGridUpdating').editorForKey('ProductSlave');
		combo.igCombo('option', 'dataSource', ds || null);
	}
	function initMaps() {
		// do only once
		if (productMap)
			return;
		// process start edit-row event in order to adjust dataSource in slave combo according to value in main combo
		var updating = $('#Grid1').data('igGridUpdating');
		updating.options.editCellStarting = function (evt, ui) {
			if (ui.columnKey === 'ProductSlave')
				initSlaveComboDS(ui);
		};
		// find columns which displayed values should be mapped
		var cols = updating.options.columnSettings;
		var i, productDS;
		for (i = 0; i < cols.length; ++i) {
			if (cols[i].columnKey === 'Product') {
				// that is dataSource of editor used for Product column defined by server
				productDS = cols[i].editorOptions.dataSource;
				// also process selectionChange in main combo to update dataSource in slave combo
				cols[i].editorOptions.selectionChanged = function (evt, ui) {
					initSlaveComboDS(null, ui.items ? ui.items[0].value : -1);
				};
			}
			if (cols[i].columnKey === 'ProductSlave')
				// that is dataSource of editor used for SlaveProduct column defined by server
				slaveDataSource = cols[i].editorOptions.dataSource;
		}
		// fill map for formatter used by Product column
		productMap = [];
		i = productDS.length;
		while (i-- > 0)
			productMap[productDS[i].ProductKey] = productDS[i].Name;
		// fill map for formatter used by SlaveProduct column
		slaveMap = [];
		i = slaveDataSource.length;
		while (i-- > 0)
			slaveMap[slaveDataSource[i].SlaveKey] = slaveDataSource[i].Name;
	}
	</script>

</head>
<body style="background:#c0e0e0;">
	<form id="validationForm" method="post">
		<%= Html.Infragistics().Grid("Grid1", Model.Grid1) %>
		<button id="btnSubmit" type="submit">Submit</button>
	</form>
</body>
</html>
